texture UITex : ERUI;
sampler SamplerUI { Texture = UITex; AddressU = Clamp; AddressV = Clamp; MipFilter = Linear; MinFilter = Linear; MagFilter = Linear; };
texture BackBufferTex : COLOR;
sampler BackBuffer { Texture = BackBufferTex; };

void PS_UIComposite(in float4 position : SV_Position, in float2 texcoord : TEXCOORD, out float3 color : SV_Target)
{
	float4 uiColor = tex2D(SamplerUI, texcoord);
	float4 hudlessColor = tex2D(BackBuffer, texcoord);
	
	color = lerp(hudlessColor, uiColor, (1-uiColor.a)).rgb;
}

// Vertex shader generating a triangle covering the entire screen
void PostProcessVS(in uint id : SV_VertexID, out float4 position : SV_Position, out float2 texcoord : TEXCOORD)
{
	texcoord.x = (id == 2) ? 2.0 : 0.0;
	texcoord.y = (id == 1) ? 2.0 : 0.0;
	position = float4(texcoord * float2(2.0, -2.0) + float2(-1.0, 1.0), 0.0, 1.0);
}

technique EldenRingUpscalerUIComposite <
	ui_tooltip = "This shader is used by Elden Ring Upscaler to do UI composite.\n";
>

{
	pass
	{
		VertexShader = PostProcessVS;
		PixelShader = PS_UIComposite;
	}
}
